/* $Id$ */
/**************************************************************************
 *
 *  FILE            cmdq.c
 *  MODULE OF       mpeg_play library.
 *
 *  DESCRIPTION     Routines for queuing commands in the client.
 *
 *  WRITTEN BY      Sverre H. Huseby <sverrehu@ifi.uio.no>
 *
 **************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "mpeg_proc.h"

/**************************************************************************
 *                                                                        *
 *                       P R I V A T E    D A T A                         *
 *                                                                        *
 **************************************************************************/

#define MAX_QUEUE 100

typedef struct _CmdEntry {
    int cmd;
    int parameter;
} CmdEntry;

static CmdEntry queue[MAX_QUEUE];
static int nQueue = 0;



int
mpCmdQueueIsEmpty(void)
{
    return nQueue == 0;
}

int
mpCmdQueueAdd(int cmd, int parameter)
{
    if (nQueue == MAX_QUEUE) {
	fprintf(stderr, "command queue full\n");
	return -1;
    }
    memmove(&queue[1], &queue[0], nQueue * sizeof(CmdEntry));
    ++nQueue;
    queue[0].cmd = cmd;
    queue[0].parameter = parameter;
    return 0;
}

int
mpCmdQueueGet(int *cmd, int *parameter)
{
    if (nQueue == 0)
	return -1;
    *cmd = queue[0].cmd;
    *parameter = queue[0].parameter;
    --nQueue;
    memmove(&queue[0], &queue[1], nQueue * sizeof(CmdEntry));
    return 0;
}
