/* this file is CLEAN2 [sverrehu] */

/* 
 * Copyright (c) 1995 The Regents of the University of California.
 * All rights reserved.
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 */

/* 
 * Portions of this software Copyright (c) 1995 Brown University.
 * All rights reserved.
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement
 * is hereby granted, provided that the above copyright notice and the
 * following two paragraphs appear in all copies of this software.
 * 
 * IN NO EVENT SHALL BROWN UNIVERSITY BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF BROWN
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * BROWN UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS"
 * BASIS, AND BROWN UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE,
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 */

#include <stdlib.h>		/* used by almost all modules */

/* 16bit.c */
void InitColorDither(int thirty2);
void Color16DitherImage(unsigned char *lum, unsigned char *cr,
			unsigned char *cb, unsigned char *out,
			int rows, int cols);
void Color32DitherImage(unsigned char *lum, unsigned char *cr,
			unsigned char *cb, unsigned char *out,
			int rows, int cols);

/* 2x2.c */
void Init2x2Dither(void);
void PostInit2x2Dither(void);
void Twox2DitherImage(unsigned char *lum, unsigned char *cr,
		      unsigned char *cb, unsigned char *out,
		      int h, int w);

/* decoders.c */
void init_tables(void);

/* fs2fast.c */
void InitFS2FastDither(void);
void FS2FastDitherImage(unsigned char *lum, unsigned char *cr,
			unsigned char *cb, unsigned char *out,
			int h, int w);

/* gdith.c */
void InitColor(void);
#ifdef SH_MEM
void InstallXErrorHandler(Display *display);
void DeInstallXErrorHandler(Display *display);
#endif
void ResizeDisplay(unsigned int w, unsigned int h, XInfo *xinfo);
void InitDisplay(char *name, XInfo *xinfo);
void InitGrayDisplay(char *name, XInfo *xinfo);
void InitColorDisplay(char *name, XInfo *xinfo);
void ExecuteDisplay(VidStream *vid_stream, XInfo *xinfo);

/* gray.c */
void GrayDitherImage(unsigned char *lum, unsigned char *cr,
		     unsigned char *cb, unsigned char *out,
		     int h, int w);
void Gray16DitherImage(unsigned char *lum, unsigned char *cr,
		       unsigned char *cb, unsigned char *p_out,
		       int h, int w);
void Gray32DitherImage(unsigned char *lum, unsigned char *cr,
		       unsigned char *cb, unsigned char *p_out,
		       int h, int w);
void Gray2DitherImage(unsigned char *lum, unsigned char *cr,
		      unsigned char *cb, unsigned char *p_out,
		      int h, int w);
void Gray216DitherImage(unsigned char *lum, unsigned char *cr,
			unsigned char *cb, unsigned char *p_out,
			int h, int w);
void Gray232DitherImage(unsigned char *lum, unsigned char *cr,
			unsigned char *cb, unsigned char *p_out,
			int h, int w);

/* hybrid.c */
void InitHybridDither(void);
void HybridDitherImage(unsigned char *lum, unsigned char *cr,
		       unsigned char *cb, unsigned char *out,
		       int h, int w);

/* jrevdct.c */
void init_pre_idct(void);
void j_rev_dct_sparse(DCTBLOCK data, int pos);
void j_rev_dct(DCTBLOCK data);

/* motionvector.c */
void ComputeForwVector(int *recon_right_for_ptr, int *recon_down_for_ptr,
		       VidStream *the_stream);
void ComputeBackVector(int *recon_right_back_ptr, int *recon_down_back_ptr,
		       VidStream *the_stream);

/* mpeg_proc.c */
/* prototypes in mpeg_proc.h */

/* mpeg_api.c */
/* prototypes in mpeg_play.h */

/* ordered2.c */
void InitOrdered2Dither(void);
void Ordered2DitherImage(unsigned char *lum, unsigned char *cr,
			 unsigned char *cb, unsigned char *out,
			 int h, int w);

/* parseblock.c */
void ParseReconBlock(int n, VidStream * vid_stream);
void ParseAwayBlock(int n, VidStream *vid_stream);

/* readfile.c */
int get_more_data(VidStream *vid_stream);
void clear_data_stream(VidStream *vid_stream);

/* util.c */
void correct_underflow(VidStream *vid_stream);
int next_bits(int num, unsigned int mask, VidStream *vid_stream);
char *get_ext_data(VidStream *vid_stream);
int next_start_code(VidStream *vid_stream);
char *get_extra_bit_info(VidStream *vid_stream);

/* util32.c */
Visual *FindFullColorVisual(Display *dpy, int *depth);
void CreateFullColorWindow(XInfo *xinfo);

/* video.c */
void InitCrop(void);
VidStream *NewVidStream(unsigned int buffer_len);
void ResetVidStream(VidStream *vid);
void DestroyVidStream(VidStream *astream, XInfo *xinfo);
VidStream *mpegVidRsrc(TimeStamp time_stamp, VidStream *vid_stream,
		       int first, XInfo *xinfo);
